--Lists the prefabs being loaded.
PrefabFiles = 
{
	"firetrap",
	"lighter_shadow",
	"lighterfire_shadow",
}

Assets = 
{

}

GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.willow = "*Likes fire, maybe too much \n*Can craft fire-related things to help her \n*Can't keep warm when insane"

local TUNING = GLOBAL.TUNING
local FUELTYPE = GLOBAL.FUELTYPE
local ACTIONS = GLOBAL.ACTIONS
local TECH = GLOBAL.TECH
local RECIPETABS = GLOBAL.RECIPETABS

TUNING.WILLOW_SANITY_MODIFIER = 1

TUNING.WILLOW_DAPPERNESS_MODIFIER = 0.75
TUNING.WILLOW_FUEL_MULT = 1.33
TUNING.WILLOW_FIRE_SANITY = 
{
	BONUS = 15 / 60,
	BONUS_CAP = 2, --per second	
	
	--Willow loses sanity over time, increased for each segment she's been away from a fire.
	PENALTY_PER_SEG = -1/60,
	NO_PENALTY_SEGS = 3,
	MAX_PENALTY_SEGS = 12,
	
}
TUNING.WILLOW_FIRE_IMMUNE_THRESHOLD = 0.75
TUNING.WILLOW_HEAT_RESIST_THRESHOLD = 0.75
TUNING.WILLOW_COLD_WEAKNESS_THRESHOLD = 0.35

TUNING.LIGHTER_SHADOW_DAPPERNESS = 0.25
TUNING.LIGHTER_SHADOW_SANITY_THRESHOLD = 0.35
TUNING.LIGHTER_SHADOW_SPEEDMULT = 1.1

AddRecipe("lighter_shadow", {Ingredient("ash", 10), Ingredient("nightmarefuel", 5), Ingredient("redgem", 1)}, RECIPETABS.MAGIC, TECH.MAGIC_THREE, nil, nil, nil, nil, "pyromaniac", "images/inventoryimages/lighter_shadow.xml", "lighter_shadow.tex")
AddMinimapAtlas("images/map_icons/lighter_shadow.xml")

GLOBAL.STRINGS.NAMES.LIGHTER_SHADOW = "Willow's Shadowflame"
GLOBAL.STRINGS.RECIPE_DESC.LIGHTER_SHADOW = "Rekindle your dreams."
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.LIGHTER_SHADOW = "Is it... fire? I'm not touching that."
GLOBAL.STRINGS.CHARACTERS.WILLOW.DESCRIBE.LIGHTER_SHADOW = "It might be a little evil, but it's cute!"

GLOBAL.STRINGS.CHARACTERS.WILLOW.ANNOUNCE_NOFIRE1 = "Nothing's really burning around here, huh?"
GLOBAL.STRINGS.CHARACTERS.WILLOW.ANNOUNCE_NOFIRE2 = "Let's burn something!"
GLOBAL.STRINGS.CHARACTERS.WILLOW.ANNOUNCE_NOFIRE3 = "I.. think everything here... needs to burn..."

TUNING.FIRETRAP_DAMAGE = 30
TUNING.FIRETRAP_USES = 15
TUNING.FIRETRAP_FIRECOUNT = 4
TUNING.FIRETRAP_FIRE_RANGE = 5
TUNING.FIRETRAP_FIRE_DAMAGE = 3

AddRecipe("firetrap", {Ingredient("trap_teeth", 1), Ingredient("redgem", 1), Ingredient("charcoal", 4)}, RECIPETABS.WAR, TECH.SCIENCE_TWO, nil, nil, nil, nil, "pyromaniac", "images/inventoryimages/firetrap.xml", "firetrap.tex")

GLOBAL.STRINGS.NAMES.FIRETRAP = "Fire Trap"
GLOBAL.STRINGS.RECIPE_DESC.FIRETRAP = "Emits a burst of fire when stepped on."
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.FIRETRAP = "Dangerous, but effective."
GLOBAL.STRINGS.CHARACTERS.WILLOW.DESCRIBE.FIRETRAP = "Hehe! I love these."


if GetModConfigData(true) then
	GLOBAL.AllRecipes.bernie_inactive.level = GLOBAL.TECH.LOST
	
	if GLOBAL.TheNet:GetIsServer() then
		local function removebernie(inst)
			inst:DoTaskInTime(0, function(inst) inst:Remove() end)
		end

		AddPrefabPostInit("bernie_inactive", removebernie)
		AddPrefabPostInit("bernie_active", removebernie)
	end
end

if not GLOBAL.TheNet:GetIsServer() then return end

---------- WILLOW ----------
local function willowfiresanityfn(inst)
    local x, y, z = inst.Transform:GetWorldPosition() 
    local delta = 0
    local max_rad = 10
    local ents = TheSim:FindEntities(x, y, z, max_rad, { "fire" }, { "willowsanityexcluded" })
    for i, v in ipairs(ents) do
		if v and v.components.burnable ~= nil and v.components.burnable:IsBurning() then
			local rad = v.components.burnable:GetLargestLightRadius() or 1
			local sz = TUNING.WILLOW_FIRE_SANITY.BONUS * math.min(max_rad, rad) / max_rad
			local distsq = inst:GetDistanceSqToInst(v) - 9
			-- shift the value so that a distance of 3 is the minimum
			delta = delta + sz / math.max(1, distsq)
		end
    end
    return math.min(delta, TUNING.WILLOW_FIRE_SANITY.BONUS_CAP)
end

AddPrefabPostInit("torch", function(inst)
	inst:AddTag("willowsanityexcluded")
end)

--Gain sanity near fire, lose an increasing amount of sanity if away from it
local function willowsanityfn(inst)
	local sanitydelta = 0
	local firesanity = willowfiresanityfn(inst)

	if firesanity > 0 then
		sanitydelta = firesanity
		inst.lastTimeNearFire = GLOBAL.GetTime()
		
		inst.shouldComplain1 = true
		inst.shouldComplain2 = true
		inst.shouldComplain3 = true
	else
		if inst.lastTimeNearFire == nil then inst.lastTimeNearFire = GLOBAL.GetTime() end --Just in case.
		local timeSinceNearFire = GLOBAL.GetTime() - inst.lastTimeNearFire
		
		local sanityPenaltySegs = math.clamp(timeSinceNearFire / TUNING.SEG_TIME - TUNING.WILLOW_FIRE_SANITY.NO_PENALTY_SEGS, 0, TUNING.WILLOW_FIRE_SANITY.MAX_PENALTY_SEGS)
		sanitydelta = TUNING.WILLOW_FIRE_SANITY.PENALTY_PER_SEG * sanityPenaltySegs
		
		--Complain
		if sanitydelta < -.02 and inst.shouldComplain1 then --When the arrows shows up
			inst.components.talker:Say(GLOBAL.GetString(inst, "ANNOUNCE_NOFIRE1"))
			inst.shouldComplain1 = false
		end
		
		if (sanityPenaltySegs >= TUNING.WILLOW_FIRE_SANITY.MAX_PENALTY_SEGS / 2) and inst.shouldComplain2 then
			inst.components.talker:Say(GLOBAL.GetString(inst, "ANNOUNCE_NOFIRE2"))
			inst.shouldComplain2 = false
		end
		
		if sanityPenaltySegs == TUNING.WILLOW_FIRE_SANITY.MAX_PENALTY_SEGS and inst.shouldComplain3 then
			inst.components.talker:Say(GLOBAL.GetString(inst, "ANNOUNCE_NOFIRE3"))
			inst.shouldComplain3 = false
		end
		
	end
	
	return sanitydelta
end

local function willowAdjustResistance(inst)
	--Fire immunity
	if inst.components.sanity:GetPercent() >= TUNING.WILLOW_FIRE_IMMUNE_THRESHOLD then
		inst.components.health.fire_damage_scale = 0
	else
		inst.components.health.fire_damage_scale = TUNING.WILLOW_FIRE_DAMAGE
	end
	
	--Heat resistance
	if inst.components.sanity:GetPercent() >= TUNING.WILLOW_HEAT_RESIST_THRESHOLD then
		inst.components.temperature.inherentsummerinsulation = TUNING.INSULATION_MED
	else
		inst.components.temperature.inherentsummerinsulation = 0
	end
end

AddPrefabPostInit("willow", function(inst)
	inst:AddTag("expertstoker") --Bonus to burnable fuel usage

	inst.components.sanity.custom_rate_fn = willowsanityfn
	inst.components.sanity.dapperness_mult_positive = TUNING.WILLOW_DAPPERNESS_MODIFIER
	
	inst.shouldComplain1 = true
	inst.shouldComplain2 = true
	inst.shouldComplain3 = true
	
	--Willow resists fire and heat variably
	inst.resistanceTask = inst:DoPeriodicTask(1, willowAdjustResistance)
	
	local _OnSave = inst.OnSave
	inst.OnSave = function(inst, data)
		_OnSave(inst, data)
		data.timeSinceNearFire = GLOBAL.GetTime() - (inst.lastTimeNearFire or 0) --Time isn't persistant between saves, so we should store the delta
		
		data.shouldComplain1 = inst.shouldComplain1
		data.shouldComplain2 = inst.shouldComplain2
		data.shouldComplain3 = inst.shouldComplain3
	end
	
	local _OnLoad = inst.OnLoad
	inst.OnLoad = function(inst, data)
		_OnLoad(inst, data)
		inst.lastTimeNearFire = GLOBAL.GetTime() - (data.timeSinceNearFire or 0)
		
		--Since this is a mod, this data might not be stored. Default to true if it's nil
		inst.shouldComplain1 = data.shouldComplain1 == nil or data.shouldComplain1
		inst.shouldComplain2 = data.shouldComplain2 == nil or data.shouldComplain2
		inst.shouldComplain3 = data.shouldComplain3 == nil or data.shouldComplain3
	end
end)

---------- SANITY GAIN MODIFER ----------
AddComponentPostInit("sanity", function(self)
	local _Recalc = self.Recalc
	function self:Recalc(...)
		if self.dapperness_mult_positive then
			--Precaclulate, and see if dapperness will be > 0
			local total_dapperness = self.dapperness
			for k, v in pairs(self.inst.components.inventory.equipslots) do
				if v.components.equippable ~= nil then
					total_dapperness = total_dapperness + v.components.equippable:GetDapperness(self.inst)
				end
			end
			
			if total_dapperness > 0 then
				self.dapperness_mult = self.dapperness_mult_positive
			else
				self.dapperness_mult = 1
			end
		end
		
		return _Recalc(self, ...)
	end
end)

---------- FUEL USAGE MODIFIER ----------
AddComponentPostInit("fueled", function(self)
    function self:TakeFuelItem(item, owner)
	
		--Does't exactly belong here, but in the interest of overriding less functions...
		if self.fuelertagneeded and not owner:HasTag(self.fuelertagneeded) then
			return false
		end
	
		if self:CanAcceptFuelItem(item) then			
			local oldsection = self:GetCurrentSection()
			
			--Character multiplier
			local charmult = 1
			if owner ~= nil then
				if owner:HasTag("expertstoker") and item.components.fuel.fueltype == FUELTYPE.BURNABLE then
					charmult = charmult * TUNING.WILLOW_FUEL_MULT
				end
			end

			local wetmult = item:GetIsWet() and TUNING.WET_FUEL_PENALTY or 1
			self:DoDelta(item.components.fuel.fuelvalue * self.bonusmult * wetmult * charmult)

			if item.components.fuel then
				item.components.fuel:Taken(self.inst)
			end
			item:Remove()

			if self.ontakefuelfn then
				self.ontakefuelfn(self.inst)
			end

			return true
		end
	end
end)

--Override add fuel actions to pass the character preforming them, so we can check later

ACTIONS.ADDFUEL.fn = function(act)
    if act.doer.components.inventory then
        local fuel = act.doer.components.inventory:RemoveItem(act.invobject)
        if fuel then
            if act.target.components.fueled:TakeFuelItem(fuel, act.doer) then
                return true
            else
                --print("False")
                act.doer.components.inventory:GiveItem(fuel)
            end
        end
    end
end

ACTIONS.ADDWETFUEL.fn = function(act)
    if act.doer.components.inventory then
        local fuel = act.doer.components.inventory:RemoveItem(act.invobject)
        if fuel then
            if act.target.components.fueled:TakeFuelItem(fuel, act.doer) then
                return true
            else
                -- print("False")
                act.doer.components.inventory:GiveItem(fuel)
            end
        end
    end
end

---------- LIGHTER ----------
--Other characters drop the lighter when it's equipped, preventing them from using it.
--I'm not using this anymore, we'll let Willow share her lighter if she so desires.
local function ligher_forcedrop(inst, owner)
	if not owner:HasTag("pyromaniac") then
		--lighter burns, drop it
		if owner.components.health ~= nil then
            owner.components.health:DoFireDamage(5, inst, true)
            owner:PushEvent("burnt")
        end
		
		owner:DoTaskInTime(0, function()
			owner.components.inventory:DropItem(inst, nil, true)
		end)
	end
end

AddPrefabPostInit("lighter", function(inst)
	inst:AddTag("willowsanityexcluded") --Willow doesn't gain sanity from the lighter's fire
	
	--Lighter can be refueled, but only by Willow
	inst.components.fueled.accepting = true
	inst.components.fueled.bonusmult = 1 / TUNING.WILLOW_FUEL_MULT --Willow's bonus doesn't work on her lighter
	inst.components.fueled.fuelertagneeded = "pyromaniac"
	
	--[[
	local _onequip = inst.components.equippable.onequipfn
	local _onunequip = inst.components.equippable.onunequipfn
	
	inst.components.equippable:SetOnEquip(function(inst, owner)
		ligher_forcedrop(inst, owner)
		_onequip(inst, owner)
	end)
	
	inst.components.equippable:SetOnUnequip(function(inst, owner)
		_onunequip(inst, owner)
	end)
	]]
end)
